/* Terraform - (C) 1997-1999 Robert Gasch (Robert_Gasch@peoplesoft.com)
 *  - www.peoplesoft.com/peoplepages/g/robert_gasch/terraform/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef _TF_DIALOG_MERGE_H
#define _TF_DIALOG_MERGE_H


#include "GuiDialogOAC.h"				// include gtk, gtk--
#include "HeightFieldDraw.h"
#include "flexarray.h"


#define MENU_MERGE_ADD		"Add"
#define MENU_MERGE_SUB		"Subtract"
#define MENU_MERGE_MULT		"Multiply"
#define MENU_MERGE_DIV		"Divide"
#define MENU_MERGE_MIN		"Minimum"
#define MENU_MERGE_MAX		"Maximum"



/*
 *  TFDialogMerge: display the roughen dialog for terraformer
 */
class TFDialogMerge : public GuiDialogOAC
	{
	public: 
				TFDialogMerge (FlexArray *winList);
				~TFDialogMerge (); 
		void		buildDialogWindow ();
		void 		buttonCallbackApply ();
		void		initHeightFields ();
		void		rebuildCList ();

	private:
		void		insertCList();
		void		insertAssignButtons ();
		void		insertSourcePreviews ();
		void		insertDestPreviews ();
		void		rowSelectedCallback (int row, int col, GdkEvent *e);
		void		button1Callback ();
		void		button2Callback ();
		gint		processCListButtonPress (GdkEventButton *e);
		void		updatePreviewCallback ();

		int			d_lastSelect;
		Gtk_VBox		d_vBox1,
					d_vBox2,
					d_vBox3,
					d_vBox4;
		Gtk_HBox		d_hbMain,
					d_hbFactor1, d_hbFactor2;
		Gtk_Button		d_btn1, d_btn2;
		Gtk_HSeparator		d_hSep;
		FlexArray		*d_winList;
		HeightField		*d_HF1, *d_HF1Preview,
					*d_HF2, *d_HF2Preview,	
					*d_HF3, *d_HF3Preview;	
		HeightFieldDraw		*d_HFD1, *d_HFD1Preview,
					*d_HFD2, *d_HFD2Preview,
					*d_HFD3, *d_HFD3Preview;
		GuiBufferedDrawingArea	*d_drawArea1, *d_drawArea2, *d_drawArea3;
		Gtk_CList		*d_cList;
		Gtk_Combo		*d_cmbMethod;
		GList			*d_glstMethod;
		Gtk_Frame		*d_previewFrame1,
					*d_previewFrame2,
					*d_previewFrame3,
					*d_frameGrp1,
					*d_frameGrp2;
		Gtk_ScrolledWindow	*d_scrolledWin;
		Gtk_Label		*d_lblFactor1, *d_lblFactor2;
		Gtk_Adjustment		*d_adjFactor1, *d_adjFactor2;
		Gtk_HScale		*d_hsFactor1, *d_hsFactor2;
		Gtk_Pixmap		*d_pixmap1, *d_pixmap2;
		Gtk_Packer		*d_packSourceMain, *d_packSourceGrp1, 
					*d_packSourceGrp2, *d_packAssignButtons;
	};


#endif // _TF_DIALOG_MERGE_H
